#ifndef _PTR_WRAPPER_H_
#define _PTR_WRAPPER_H_

#include <cstdlib>

template <class T>
class PtrWrapper {
public:
    PtrWrapper(T* t = NULL) : _ptr(t) {}

    PtrWrapper(const PtrWrapper& w) : _ptr(w._ptr) {}

    ~PtrWrapper() {}

    PtrWrapper& operator= (const PtrWrapper& w) {
        _ptr = w._ptr;
        return *this;
    }

    T* operator-> () { return _ptr;}

    T* operator() () { return _ptr;}

private:
    T* _ptr;
};

template <class T>
bool operator== (const PtrWrapper<T>& w1, const PtrWrapper<T>& w2) {
    return(w1.operator()() && w2.operator()()) ? *w1() == *w2() : false;
}

#endif // _PTR_WRAPPER_H_

